# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['CnameRecordArgs', 'CnameRecord']

@pulumi.input_type
class CnameRecordArgs:
    def __init__(__self__, *,
                 domain: pulumi.Input[str],
                 target: pulumi.Input[str]):
        """
        The set of arguments for constructing a CnameRecord resource.
        :param pulumi.Input[str] domain: Domain to create a CNAME record for
        :param pulumi.Input[str] target: Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        pulumi.set(__self__, "domain", domain)
        pulumi.set(__self__, "target", target)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Input[str]:
        """
        Domain to create a CNAME record for
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: pulumi.Input[str]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def target(self) -> pulumi.Input[str]:
        """
        Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: pulumi.Input[str]):
        pulumi.set(self, "target", value)


@pulumi.input_type
class _CnameRecordState:
    def __init__(__self__, *,
                 domain: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CnameRecord resources.
        :param pulumi.Input[str] domain: Domain to create a CNAME record for
        :param pulumi.Input[str] target: Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if target is not None:
            pulumi.set(__self__, "target", target)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[str]]:
        """
        Domain to create a CNAME record for
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def target(self) -> Optional[pulumi.Input[str]]:
        """
        Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target", value)


class CnameRecord(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages a Pi-hole CNAME record

        ## Example Usage

        ```python
        import pulumi
        import unmango_pulumi_pihole as pihole

        record = pihole.CnameRecord("record",
            domain="foo.com",
            target="bar.com")
        ```

        ## Import

        ```sh
        $ pulumi import pihole:index/cnameRecord:CnameRecord record foo.com
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Domain to create a CNAME record for
        :param pulumi.Input[str] target: Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CnameRecordArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a Pi-hole CNAME record

        ## Example Usage

        ```python
        import pulumi
        import unmango_pulumi_pihole as pihole

        record = pihole.CnameRecord("record",
            domain="foo.com",
            target="bar.com")
        ```

        ## Import

        ```sh
        $ pulumi import pihole:index/cnameRecord:CnameRecord record foo.com
        ```

        :param str resource_name: The name of the resource.
        :param CnameRecordArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CnameRecordArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CnameRecordArgs.__new__(CnameRecordArgs)

            if domain is None and not opts.urn:
                raise TypeError("Missing required property 'domain'")
            __props__.__dict__["domain"] = domain
            if target is None and not opts.urn:
                raise TypeError("Missing required property 'target'")
            __props__.__dict__["target"] = target
        super(CnameRecord, __self__).__init__(
            'pihole:index/cnameRecord:CnameRecord',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            domain: Optional[pulumi.Input[str]] = None,
            target: Optional[pulumi.Input[str]] = None) -> 'CnameRecord':
        """
        Get an existing CnameRecord resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Domain to create a CNAME record for
        :param pulumi.Input[str] target: Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CnameRecordState.__new__(_CnameRecordState)

        __props__.__dict__["domain"] = domain
        __props__.__dict__["target"] = target
        return CnameRecord(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[str]:
        """
        Domain to create a CNAME record for
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def target(self) -> pulumi.Output[str]:
        """
        Value of the CNAME record where traffic will be directed to from the configured domain value
        """
        return pulumi.get(self, "target")

